import type { INodeType, INodeTypeDescription, INodeTypes, IVersionedNodeType } from 'n8n-workflow';
import { LoadNodesAndCredentials } from './LoadNodesAndCredentials';
export declare class NodeTypes implements INodeTypes {
    private loadNodesAndCredentials;
    constructor(loadNodesAndCredentials: LoadNodesAndCredentials);
    getWithSourcePath(nodeTypeName: string, version: number): {
        description: INodeTypeDescription;
    } & {
        sourcePath: string;
    };
    getByName(nodeType: string): INodeType | IVersionedNodeType;
    getByNameAndVersion(nodeType: string, version?: number): INodeType;
    applySpecialNodeParameters(): void;
    private getNode;
    getNodeTranslationPath({ nodeSourcePath, longNodeType, locale, }: {
        nodeSourcePath: string;
        longNodeType: string;
        locale: string;
    }): Promise<string>;
    private getMaxVersion;
    private isVersionedDirname;
}
