import type { User } from '../../../../databases/entities/User';
import { WorkflowEntity } from '../../../../databases/entities/WorkflowEntity';
import { SharedWorkflow, type WorkflowSharingRole } from '../../../../databases/entities/SharedWorkflow';
export declare function getSharedWorkflowIds(user: User): Promise<string[]>;
export declare function getSharedWorkflow(user: User, workflowId?: string | undefined): Promise<SharedWorkflow | null>;
export declare function getWorkflowById(id: string): Promise<WorkflowEntity | null>;
export declare function createWorkflow(workflow: WorkflowEntity, user: User, role: WorkflowSharingRole): Promise<WorkflowEntity>;
export declare function setWorkflowAsActive(workflow: WorkflowEntity): Promise<void>;
export declare function setWorkflowAsInactive(workflow: WorkflowEntity): Promise<import("@n8n/typeorm").UpdateResult>;
export declare function deleteWorkflow(workflow: WorkflowEntity): Promise<WorkflowEntity>;
export declare function updateWorkflow(workflowId: string, updateData: WorkflowEntity): Promise<import("@n8n/typeorm").UpdateResult>;
export declare function parseTagNames(tags: string): string[];
export declare function getWorkflowTags(workflowId: string): Promise<import("../../../../databases/entities/TagEntity").TagEntity[]>;
export declare function updateTags(workflowId: string, newTags: string[]): Promise<any>;
