import type express from 'express';
import { Workflow } from 'n8n-workflow';
import type { IWebhookData, IWorkflowExecuteAdditionalData, IHttpRequestMethods, IRunData } from 'n8n-workflow';
import type { IResponseCallbackData, IWebhookManager, IWorkflowDb, WebhookAccessControlOptions, WebhookRequest } from './Interfaces';
import { Push } from './push';
import { NodeTypes } from './NodeTypes';
import { TestWebhookRegistrationsService } from './services/test-webhook-registrations.service';
import { OrchestrationService } from './services/orchestration.service';
export declare class TestWebhooks implements IWebhookManager {
    private readonly push;
    private readonly nodeTypes;
    private readonly registrations;
    private readonly orchestrationService;
    constructor(push: Push, nodeTypes: NodeTypes, registrations: TestWebhookRegistrationsService, orchestrationService: OrchestrationService);
    private timeouts;
    executeWebhook(request: WebhookRequest, response: express.Response): Promise<IResponseCallbackData>;
    clearTimeout(key: string): void;
    getWebhookMethods(path: string): Promise<IHttpRequestMethods[]>;
    findAccessControlOptions(path: string, httpMethod: IHttpRequestMethods): Promise<WebhookAccessControlOptions | undefined>;
    needsWebhook(userId: string, workflowEntity: IWorkflowDb, additionalData: IWorkflowExecuteAdditionalData, runData?: IRunData, pushRef?: string, destinationNode?: string): Promise<boolean>;
    cancelWebhook(workflowId: string): Promise<boolean>;
    getActiveWebhook(httpMethod: IHttpRequestMethods, path: string, webhookId?: string): Promise<IWebhookData | undefined>;
    deactivateWebhooks(workflow: Workflow): Promise<void>;
    toWorkflow(workflowEntity: IWorkflowDb): Workflow;
}
