import type express from 'express';
import { NodeTypes } from './NodeTypes';
import type { IExecutionResponse, IResponseCallbackData, IWebhookManager, WaitingWebhookRequest } from './Interfaces';
import { ExecutionRepository } from './databases/repositories/execution.repository';
import { OwnershipService } from './services/ownership.service';
import { Logger } from './Logger';
export declare class WaitingWebhooks implements IWebhookManager {
    protected readonly logger: Logger;
    private readonly nodeTypes;
    private readonly executionRepository;
    private readonly ownershipService;
    protected includeForms: boolean;
    constructor(logger: Logger, nodeTypes: NodeTypes, executionRepository: ExecutionRepository, ownershipService: OwnershipService);
    protected logReceivedWebhook(method: string, executionId: string): void;
    protected disableNode(execution: IExecutionResponse, _method?: string): void;
    executeWebhook(req: WaitingWebhookRequest, res: express.Response): Promise<IResponseCallbackData>;
}
