import { Request, Response, NextFunction } from 'express';
import { NodeRequest } from '../requests';
import type { InstalledPackages } from '../databases/entities/InstalledPackages';
import { InternalHooks } from '../InternalHooks';
import { Push } from '../push';
import { CommunityPackagesService } from '../services/communityPackages.service';
export declare function isNpmError(error: unknown): error is {
    code: number;
    stdout: string;
};
export declare class CommunityPackagesController {
    private readonly push;
    private readonly internalHooks;
    private readonly communityPackagesService;
    constructor(push: Push, internalHooks: InternalHooks, communityPackagesService: CommunityPackagesService);
    checkIfCommunityNodesEnabled(req: Request, res: Response, next: NextFunction): void;
    installPackage(req: NodeRequest.Post): Promise<InstalledPackages>;
    getInstalledPackages(): Promise<InstalledPackages[] | import("n8n-workflow").PublicInstalledPackage[]>;
    uninstallPackage(req: NodeRequest.Delete): Promise<void>;
    updatePackage(req: NodeRequest.Update): Promise<InstalledPackages>;
}
