import { ActiveWorkflowRunner } from '../ActiveWorkflowRunner';
import { OrchestrationService } from '../services/orchestration.service';
import { WorkflowRepository } from '../databases/repositories/workflow.repository';
export declare class DebugController {
    private readonly orchestrationService;
    private readonly activeWorkflowRunner;
    private readonly workflowRepository;
    constructor(orchestrationService: OrchestrationService, activeWorkflowRunner: ActiveWorkflowRunner, workflowRepository: WorkflowRepository);
    getMultiMainSetupDetails(): Promise<{
        instanceId: string;
        leaderKey: string | null | undefined;
        isLeader: boolean;
        activeWorkflows: {
            webhooks: {
                id: string;
                name: string;
            }[];
            triggersAndPollers: import("../databases/entities/WorkflowEntity").WorkflowEntity[];
        };
        activationErrors: import("../services/cache/cache.types").Hash<string>;
    }>;
}
