import type { EntityManager } from '@n8n/typeorm';
import type { SharedCredentials } from '../databases/entities/SharedCredentials';
import type { User } from '../databases/entities/User';
import { type CredentialsGetSharedOptions } from './credentials.service';
import { SharedCredentialsRepository } from '../databases/repositories/sharedCredentials.repository';
import { UserRepository } from '../databases/repositories/user.repository';
import { CredentialsEntity } from '../databases/entities/CredentialsEntity';
export declare class EnterpriseCredentialsService {
    private readonly userRepository;
    private readonly sharedCredentialsRepository;
    constructor(userRepository: UserRepository, sharedCredentialsRepository: SharedCredentialsRepository);
    isOwned(user: User, credentialId: string): Promise<{
        ownsCredential: boolean;
        credential?: undefined;
    } | {
        ownsCredential: boolean;
        credential: CredentialsEntity;
    }>;
    getSharing(user: User, credentialId: string, options: CredentialsGetSharedOptions, relations?: string[]): Promise<SharedCredentials | null>;
    getSharings(transaction: EntityManager, credentialId: string, relations?: string[]): Promise<SharedCredentials[]>;
    share(transaction: EntityManager, credential: CredentialsEntity, shareWithIds: string[]): Promise<SharedCredentials[]>;
}
