import { DataSource, Repository } from '@n8n/typeorm';
import type { DeleteResult, EntityManager } from '@n8n/typeorm';
import { CredentialsEntity } from '../entities/CredentialsEntity';
import type { ListQuery } from '../../requests';
export declare class CredentialsRepository extends Repository<CredentialsEntity> {
    constructor(dataSource: DataSource);
    pruneSharings(transaction: EntityManager, credentialId: string, userIds: string[]): Promise<DeleteResult>;
    findStartingWith(credentialName: string): Promise<CredentialsEntity[]>;
    findMany(listQueryOptions?: ListQuery.Options, credentialIds?: string[]): Promise<CredentialsEntity[]>;
    private toFindManyOptions;
    getManyByIds(ids: string[], { withSharings }?: {
        withSharings: boolean;
    }): Promise<CredentialsEntity[]>;
}
