"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CredentialsRepository = void 0;
const typedi_1 = require("typedi");
const typeorm_1 = require("@n8n/typeorm");
const CredentialsEntity_1 = require("../entities/CredentialsEntity");
const SharedCredentials_1 = require("../entities/SharedCredentials");
let CredentialsRepository = class CredentialsRepository extends typeorm_1.Repository {
    constructor(dataSource) {
        super(CredentialsEntity_1.CredentialsEntity, dataSource.manager);
    }
    async pruneSharings(transaction, credentialId, userIds) {
        const conditions = {
            credentialsId: credentialId,
            userId: (0, typeorm_1.Not)((0, typeorm_1.In)(userIds)),
        };
        return await transaction.delete(SharedCredentials_1.SharedCredentials, conditions);
    }
    async findStartingWith(credentialName) {
        return await this.find({
            select: ['name'],
            where: { name: (0, typeorm_1.Like)(`${credentialName}%`) },
        });
    }
    async findMany(listQueryOptions, credentialIds) {
        const findManyOptions = this.toFindManyOptions(listQueryOptions);
        if (credentialIds) {
            findManyOptions.where = { ...findManyOptions.where, id: (0, typeorm_1.In)(credentialIds) };
        }
        return await this.find(findManyOptions);
    }
    toFindManyOptions(listQueryOptions) {
        const findManyOptions = {};
        const defaultRelations = ['shared', 'shared.user'];
        const defaultSelect = ['id', 'name', 'type', 'createdAt', 'updatedAt'];
        if (!listQueryOptions)
            return { select: defaultSelect, relations: defaultRelations };
        const { filter, select, take, skip } = listQueryOptions;
        if (typeof (filter === null || filter === void 0 ? void 0 : filter.name) === 'string' && (filter === null || filter === void 0 ? void 0 : filter.name) !== '') {
            filter.name = (0, typeorm_1.Like)(`%${filter.name}%`);
        }
        if (typeof (filter === null || filter === void 0 ? void 0 : filter.type) === 'string' && (filter === null || filter === void 0 ? void 0 : filter.type) !== '') {
            filter.type = (0, typeorm_1.Like)(`%${filter.type}%`);
        }
        if (filter)
            findManyOptions.where = filter;
        if (select)
            findManyOptions.select = select;
        if (take)
            findManyOptions.take = take;
        if (skip)
            findManyOptions.skip = skip;
        if (take && select && !(select === null || select === void 0 ? void 0 : select.id)) {
            findManyOptions.select = { ...findManyOptions.select, id: true };
        }
        if (!findManyOptions.select) {
            findManyOptions.select = defaultSelect;
            findManyOptions.relations = defaultRelations;
        }
        return findManyOptions;
    }
    async getManyByIds(ids, { withSharings } = { withSharings: false }) {
        const findManyOptions = { where: { id: (0, typeorm_1.In)(ids) } };
        if (withSharings) {
            findManyOptions.relations = ['shared', 'shared.user'];
        }
        return await this.find(findManyOptions);
    }
};
exports.CredentialsRepository = CredentialsRepository;
exports.CredentialsRepository = CredentialsRepository = __decorate([
    (0, typedi_1.Service)(),
    __metadata("design:paramtypes", [typeorm_1.DataSource])
], CredentialsRepository);
//# sourceMappingURL=credentials.repository.js.map