import type { EntityManager } from '@n8n/typeorm';
import { DataSource, Repository } from '@n8n/typeorm';
import { type CredentialSharingRole, SharedCredentials } from '../entities/SharedCredentials';
import type { User } from '../entities/User';
export declare class SharedCredentialsRepository extends Repository<SharedCredentials> {
    constructor(dataSource: DataSource);
    findCredentialForUser(credentialsId: string, user: User): Promise<import("../entities/CredentialsEntity").CredentialsEntity | null>;
    findByCredentialIds(credentialIds: string[], role: CredentialSharingRole): Promise<SharedCredentials[]>;
    makeOwnerOfAllCredentials(user: User): Promise<import("@n8n/typeorm").UpdateResult>;
    getOwnedCredentialIds(userIds: string[]): Promise<string[]>;
    getAccessibleCredentialIds(userIds: string[]): Promise<string[]>;
    private getCredentialIdsByUserAndRole;
    deleteByIds(transaction: EntityManager, sharedCredentialsIds: string[], user?: User): Promise<import("@n8n/typeorm").DeleteResult>;
}
