import { AbstractEventMessage } from './AbstractEventMessage';
import type { EventNamesAiNodesType, JsonObject } from 'n8n-workflow';
import { EventMessageTypeNames } from 'n8n-workflow';
import type { AbstractEventMessageOptions } from './AbstractEventMessageOptions';
import type { AbstractEventPayload } from './AbstractEventPayload';
export interface EventPayloadAiNode extends AbstractEventPayload {
    msg?: string;
    executionId: string;
    nodeName: string;
    workflowId?: string;
    workflowName: string;
    nodeType?: string;
}
export interface EventMessageAiNodeOptions extends AbstractEventMessageOptions {
    eventName: EventNamesAiNodesType;
    payload?: EventPayloadAiNode | undefined;
}
export declare class EventMessageAiNode extends AbstractEventMessage {
    readonly __type = EventMessageTypeNames.aiNode;
    eventName: EventNamesAiNodesType;
    payload: EventPayloadAiNode;
    constructor(options: EventMessageAiNodeOptions);
    setPayload(payload: EventPayloadAiNode): this;
    deserialize(data: JsonObject): this;
}
