import type { EventMessageAiNode } from './EventMessageAiNode';
import type { EventMessageAudit } from './EventMessageAudit';
import type { EventMessageGeneric } from './EventMessageGeneric';
import type { EventMessageNode } from './EventMessageNode';
import type { EventMessageWorkflow } from './EventMessageWorkflow';
import { type EventNamesAiNodesType } from 'n8n-workflow';
export declare const eventNamesWorkflow: readonly ["n8n.workflow.started", "n8n.workflow.success", "n8n.workflow.failed", "n8n.workflow.crashed"];
export declare const eventNamesGeneric: readonly ["n8n.worker.started", "n8n.worker.stopped"];
export declare const eventNamesNode: readonly ["n8n.node.started", "n8n.node.finished"];
export declare const eventNamesAudit: readonly ["n8n.audit.user.login.success", "n8n.audit.user.login.failed", "n8n.audit.user.signedup", "n8n.audit.user.updated", "n8n.audit.user.deleted", "n8n.audit.user.invited", "n8n.audit.user.invitation.accepted", "n8n.audit.user.reinvited", "n8n.audit.user.email.failed", "n8n.audit.user.reset.requested", "n8n.audit.user.reset", "n8n.audit.user.credentials.created", "n8n.audit.user.credentials.shared", "n8n.audit.user.credentials.updated", "n8n.audit.user.credentials.deleted", "n8n.audit.user.api.created", "n8n.audit.user.api.deleted", "n8n.audit.package.installed", "n8n.audit.package.updated", "n8n.audit.package.deleted", "n8n.audit.workflow.created", "n8n.audit.workflow.deleted", "n8n.audit.workflow.updated"];
export type EventNamesWorkflowType = (typeof eventNamesWorkflow)[number];
export type EventNamesAuditType = (typeof eventNamesAudit)[number];
export type EventNamesNodeType = (typeof eventNamesNode)[number];
export type EventNamesGenericType = (typeof eventNamesGeneric)[number];
export type EventNamesTypes = EventNamesAuditType | EventNamesWorkflowType | EventNamesNodeType | EventNamesGenericType | EventNamesAiNodesType | 'n8n.destination.test';
export declare const eventNamesAll: ("n8n.audit.user.login.success" | "n8n.audit.user.login.failed" | "n8n.audit.user.signedup" | "n8n.audit.user.updated" | "n8n.audit.user.deleted" | "n8n.audit.user.invited" | "n8n.audit.user.invitation.accepted" | "n8n.audit.user.reinvited" | "n8n.audit.user.email.failed" | "n8n.audit.user.reset.requested" | "n8n.audit.user.reset" | "n8n.audit.user.credentials.created" | "n8n.audit.user.credentials.shared" | "n8n.audit.user.credentials.updated" | "n8n.audit.user.credentials.deleted" | "n8n.audit.user.api.created" | "n8n.audit.user.api.deleted" | "n8n.audit.package.installed" | "n8n.audit.package.updated" | "n8n.audit.package.deleted" | "n8n.audit.workflow.created" | "n8n.audit.workflow.deleted" | "n8n.audit.workflow.updated" | "n8n.workflow.started" | "n8n.workflow.success" | "n8n.workflow.failed" | "n8n.workflow.crashed" | "n8n.node.started" | "n8n.node.finished" | "n8n.worker.started" | "n8n.worker.stopped" | "n8n.ai.memory.get.messages" | "n8n.ai.memory.added.message" | "n8n.ai.output.parser.get.instructions" | "n8n.ai.output.parser.parsed" | "n8n.ai.retriever.get.relevant.documents" | "n8n.ai.embeddings.embedded.document" | "n8n.ai.embeddings.embedded.query" | "n8n.ai.document.processed" | "n8n.ai.text.splitter.split" | "n8n.ai.tool.called" | "n8n.ai.vector.store.searched" | "n8n.ai.llm.generated" | "n8n.ai.vector.store.populated")[];
export type EventMessageTypes = EventMessageGeneric | EventMessageWorkflow | EventMessageAudit | EventMessageNode | EventMessageAiNode;
export interface FailedEventSummary {
    lastNodeExecuted: string;
    executionId: string;
    name: string;
    event: string;
    timestamp: string;
}
