"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logStreamingLicensedMiddleware = exports.islogStreamingLicensed = void 0;
const typedi_1 = __importDefault(require("typedi"));
const License_1 = require("../../License");
function islogStreamingLicensed() {
    return typedi_1.default.get(License_1.License).isLogStreamingEnabled();
}
exports.islogStreamingLicensed = islogStreamingLicensed;
const logStreamingLicensedMiddleware = (req, res, next) => {
    if (islogStreamingLicensed()) {
        next();
    }
    else {
        res.status(403).json({ status: 'error', message: 'Unauthorized' });
    }
};
exports.logStreamingLicensedMiddleware = logStreamingLicensedMiddleware;
//# sourceMappingURL=logStreamingEnabled.middleware.ee.js.map