import { ActiveExecutions } from '../ActiveExecutions';
import { Logger } from '../Logger';
import { Queue } from '../Queue';
import { WaitTracker } from '../WaitTracker';
import { ExecutionRepository } from '../databases/repositories/execution.repository';
import type { ExecutionSummary } from 'n8n-workflow';
import type { IExecutionBase } from '../Interfaces';
import type { GetManyActiveFilter } from './execution.types';
export declare class ActiveExecutionService {
    private readonly logger;
    private readonly queue;
    private readonly activeExecutions;
    private readonly executionRepository;
    private readonly waitTracker;
    constructor(logger: Logger, queue: Queue, activeExecutions: ActiveExecutions, executionRepository: ExecutionRepository, waitTracker: WaitTracker);
    private readonly isRegularMode;
    findOne(executionId: string, accessibleWorkflowIds: string[]): Promise<IExecutionBase | undefined>;
    private toSummary;
    findManyInRegularMode(filter: GetManyActiveFilter, accessibleWorkflowIds: string[]): Promise<ExecutionSummary[]>;
    findManyInQueueMode(filter: GetManyActiveFilter, accessibleWorkflowIds: string[]): Promise<ExecutionSummary[]>;
    stop(execution: IExecutionBase): Promise<import("../Interfaces").IExecutionsStopData>;
}
