import { ExecutionRequest } from './execution.types';
import { ExecutionService } from './execution.service';
import { EnterpriseExecutionsService } from './execution.service.ee';
import { License } from '../License';
import { WorkflowSharingService } from '../workflows/workflowSharing.service';
import { ActiveExecutionService } from './active-execution.service';
export declare class ExecutionsController {
    private readonly executionService;
    private readonly enterpriseExecutionService;
    private readonly workflowSharingService;
    private readonly activeExecutionService;
    private readonly license;
    private readonly isQueueMode;
    constructor(executionService: ExecutionService, enterpriseExecutionService: EnterpriseExecutionsService, workflowSharingService: WorkflowSharingService, activeExecutionService: ActiveExecutionService, license: License);
    private getAccessibleWorkflowIds;
    getMany(req: ExecutionRequest.GetMany): Promise<{
        count: number;
        results: import("n8n-workflow").ExecutionSummary[];
        estimated: boolean;
    }>;
    getActive(req: ExecutionRequest.GetManyActive): Promise<import("n8n-workflow").ExecutionSummary[]>;
    stop(req: ExecutionRequest.Stop): Promise<import("../Interfaces").IExecutionsStopData>;
    getOne(req: ExecutionRequest.GetOne): Promise<import("../Interfaces").IExecutionResponse | import("../Interfaces").IExecutionFlattedResponse | undefined>;
    retry(req: ExecutionRequest.Retry): Promise<boolean>;
    delete(req: ExecutionRequest.Delete): Promise<void>;
}
