import type { FeatureFlags, ITelemetryTrackProperties } from 'n8n-workflow';
import { InstanceSettings } from 'n8n-core';
import type { PublicUser } from '../Interfaces';
export declare class PostHogClient {
    private readonly instanceSettings;
    private postHog?;
    constructor(instanceSettings: InstanceSettings);
    init(): Promise<void>;
    stop(): Promise<void>;
    track(payload: {
        userId: string;
        event: string;
        properties: ITelemetryTrackProperties;
    }): void;
    getFeatureFlags(user: Pick<PublicUser, 'id' | 'createdAt'>): Promise<FeatureFlags>;
}
