import type WebSocket from 'ws';
import { Logger } from '../Logger';
import { AbstractPush } from './abstract.push';
import type { User } from '../databases/entities/User';
import { OrchestrationService } from '../services/orchestration.service';
export declare class WebSocketPush extends AbstractPush<WebSocket> {
    constructor(logger: Logger, orchestrationService: OrchestrationService);
    add(pushRef: string, userId: User['id'], connection: WebSocket): void;
    protected close(connection: WebSocket): void;
    protected sendToOneConnection(connection: WebSocket, data: string): void;
    private pingAll;
}
