import type { RiskReporter, Risk } from '../../security-audit/types';
import type { WorkflowEntity } from '../../databases/entities/WorkflowEntity';
import { CredentialsRepository } from '../../databases/repositories/credentials.repository';
import { ExecutionRepository } from '../../databases/repositories/execution.repository';
import { ExecutionDataRepository } from '../../databases/repositories/executionData.repository';
export declare class CredentialsRiskReporter implements RiskReporter {
    private readonly credentialsRepository;
    private readonly executionRepository;
    private readonly executionDataRepository;
    constructor(credentialsRepository: CredentialsRepository, executionRepository: ExecutionRepository, executionDataRepository: ExecutionDataRepository);
    report(workflows: WorkflowEntity[]): Promise<Risk.StandardReport | null>;
    private getAllCredsInUse;
    private getAllExistingCreds;
    private getExecutedWorkflowsInPastDays;
    private getCredsInRecentlyExecutedWorkflows;
}
