import { InstanceSettings } from 'n8n-core';
import type { WorkflowEntity } from '../../databases/entities/WorkflowEntity';
import type { RiskReporter, Risk } from '../../security-audit/types';
export declare class InstanceRiskReporter implements RiskReporter {
    private readonly instanceSettings;
    constructor(instanceSettings: InstanceSettings);
    report(workflows: WorkflowEntity[]): Promise<Risk.InstanceReport | null>;
    private getSecuritySettings;
    private hasValidatorChild;
    private getUnprotectedWebhookNodes;
    private getNextVersions;
    private removeIconData;
    private classify;
    private getOutdatedState;
}
