import type { ICredentialsDecrypted, ICredentialTestFunction, ICredentialTestRequestData, INodeCredentialTestResult } from 'n8n-workflow';
import type { User } from '../databases/entities/User';
import { NodeTypes } from '../NodeTypes';
import { CredentialTypes } from '../CredentialTypes';
import { Logger } from '../Logger';
import { CredentialsHelper } from '../CredentialsHelper';
export declare class CredentialsTester {
    private readonly logger;
    private readonly credentialTypes;
    private readonly nodeTypes;
    private readonly credentialsHelper;
    constructor(logger: Logger, credentialTypes: CredentialTypes, nodeTypes: NodeTypes, credentialsHelper: CredentialsHelper);
    private static hasAccessToken;
    getCredentialTestFunction(credentialType: string): ICredentialTestFunction | ICredentialTestRequestData | undefined;
    testCredentials(user: User, credentialType: string, credentialsDecrypted: ICredentialsDecrypted): Promise<INodeCredentialTestResult>;
}
