/// <reference types="node" />
import { EventEmitter } from 'node:events';
import { Logger } from '../../../Logger';
import { RedisServicePubSubPublisher } from '../../../services/redis/RedisServicePubSubPublisher';
export declare class MultiMainSetup extends EventEmitter {
    private readonly logger;
    private readonly redisPublisher;
    constructor(logger: Logger, redisPublisher: RedisServicePubSubPublisher);
    get instanceId(): string;
    private readonly leaderKey;
    private readonly leaderKeyTtl;
    private leaderCheckInterval;
    init(): Promise<void>;
    shutdown(): Promise<void>;
    private checkLeader;
    private tryBecomeLeader;
    fetchLeaderKey(): Promise<string | null | undefined>;
}
