/// <reference types="node" />
import { BinaryDataService } from 'n8n-core';
import { ExecutionRepository } from '../databases/repositories/execution.repository';
import { Logger } from '../Logger';
export declare class PruningService {
    private readonly logger;
    private readonly executionRepository;
    private readonly binaryDataService;
    private hardDeletionBatchSize;
    private rates;
    softDeletionInterval: NodeJS.Timer | undefined;
    hardDeletionTimeout: NodeJS.Timeout | undefined;
    private isShuttingDown;
    constructor(logger: Logger, executionRepository: ExecutionRepository, binaryDataService: BinaryDataService);
    private isPruningEnabled;
    startPruning(): void;
    stopPruning(): void;
    private setSoftDeletionInterval;
    private scheduleHardDeletion;
    softDeleteOnPruningCycle(): Promise<void>;
    shutdown(): void;
    private hardDeleteOnPruningCycle;
}
