import { WebhookRepository } from '../databases/repositories/webhook.repository';
import { CacheService } from '../services/cache/cache.service';
import type { WebhookEntity } from '../databases/entities/WebhookEntity';
import type { IHttpRequestMethods } from 'n8n-workflow';
type Method = NonNullable<IHttpRequestMethods>;
export declare class WebhookService {
    private webhookRepository;
    private cacheService;
    constructor(webhookRepository: WebhookRepository, cacheService: CacheService);
    populateCache(): Promise<void>;
    private findCached;
    private findStaticWebhook;
    private findDynamicWebhook;
    findWebhook(method: Method, path: string): Promise<WebhookEntity | null>;
    storeWebhook(webhook: WebhookEntity): Promise<import("@n8n/typeorm").InsertResult>;
    createWebhook(data: Partial<WebhookEntity>): WebhookEntity;
    deleteWorkflowWebhooks(workflowId: string): Promise<WebhookEntity[]>;
    private deleteWebhooks;
    getWebhookMethods(path: string): Promise<IHttpRequestMethods[]>;
}
export {};
